C3DCriticalPoint Class Reference
Basic data strctures and functions

A class to hold a critical point. This class holds a critical point in a 3D vector field It consists of a localtion \( x_0 \in \mathbb{R}^3 \), Matrix \( A \in \mathbb{R}^{3 \times 3} \), and a magnitude \( \gamma \in \mathbb{R} \). It is used only as an intermidiate storage. More...

`#include <mia/3d/critical_point.hh>`

## Public Types

typedef std::vector< C3DCriticalPoint > | List
| A list of critical points.

## Public Member Functions

C3DFVector | at (const C3DFVector &x) const
C3DFVector | at_alt (const C3DFVector &x) const
| C3DCriticalPoint ()
| C3DCriticalPoint (const C3DCriticalPoint &org)
| C3DCriticalPoint (const C3DFVector &x0_)
| C3DCriticalPoint (float x, float y, float z)
const C3DFMatrix | get_a () const
float | get_gamma () const
const C3DFVector | get_point () const
C3DCriticalPoint & | operator= (const C3DCriticalPoint &org)
bool | operator== (const C3DCriticalPoint &cp) const
void | set_a (const C3DFMatrix &)
void | set_gamma (float gamma_)
void | set_point (const C3DFVector &)

## Detailed Description

A class to hold a critical point. This class holds a critical point in a 3D vector field It consists of a localtion \( x_0 \in \mathbb{R}^3 \), Matrix \( A \in \mathbb{R}^{3 \times 3} \), and a magnitude \( \gamma \in \mathbb{R} \). It is used only as an intermidiate storage.

Remarks
  partially untested

Definition at line 44 of file critical_point.hh.

## Member Typedef Documentation

## List

typedef std::vector< C3DCriticalPoint > C3DCriticalPoint::List

A list of critical points.

Definition at line 49 of file critical_point.hh.

## Constructor & Destructor Documentation

## C3DCriticalPoint() [1/4]

C3DCriticalPoint::C3DCriticalPoint | ( |  | ) |

The standart constructor. It created a critical point with a magintude of zero, at location (0,0,0) with the Zero - Matrix as phase portrait.

Referenced by at_alt(), C3DCriticalPoint(), operator=(), and operator==().

## C3DCriticalPoint() [2/4]

C3DCriticalPoint::C3DCriticalPoint | ( | const C3DFVector & | x0_ | ) |

Construct a critical point at a certain location. Magnitude and phase portrait are set to zero.

Parameters

  x0_ | location of the new critical point

## C3DCriticalPoint() [3/4]

C3DCriticalPoint::C3DCriticalPoint | ( | float | x,
|  | float | y,
|  | float | z )

Construct a critical point at a certain location. Magnitude and pahse portrait are set to zero.

Parameters

  x | x-coordinate of the new critical point
  y | y-coordinate of the new critical point
  z | z-coordinate of the new critical point

## C3DCriticalPoint() [4/4]

C3DCriticalPoint::C3DCriticalPoint | ( | const C3DCriticalPoint & | org | ) |

Copy constructor.

Parameters

  org | The critical point to be copied.

References C3DCriticalPoint().

## Member Function Documentation

## at()

C3DFVector C3DCriticalPoint::at | ( | const C3DFVector & | x | ) | const

return the magniture of the critical point at location x according to

\[ \frac {\Gamma}{ \| \mathbf{x} - \mathbf{x_0} \| ^ 2} A \dot (x - x0) \]

Parameters

  x | location weher to evaluate the vector field

Return values

  value | of vector field created by this crtitical point at x

## at_alt()

C3DFVector C3DCriticalPoint::at_alt | ( | const C3DFVector & | x | ) | const

return the magniture of the critical point at location x according to

\[ \frac {A \dot (x - x0)}{ | \| \mathbf{x} - \mathbf{x_0} \|_2 - gamma |} \]

Parameters

  x | location weher to evaluate the vector field

Return values

  value | of vector field created by this crtitical point at x

References C3DCriticalPoint().

## get_a()

const C3DFMatrix C3DCriticalPoint::get_a | ( |  | ) | const

inline

Return values

  the | (read only) phase portrait of the critical point.

Definition at line 360 of file critical_point.hh.

Referenced by operator=().

## get_gamma()

float C3DCriticalPoint::get_gamma | ( |  | ) | const

inline

Return values

  the | magnitude of the critical point

Definition at line 377 of file critical_point.hh.

Referenced by operator=().

## get_point()

const C3DFVector C3DCriticalPoint::get_point | ( |  | ) | const

inline

Return values

  the | (read only) location of the critical point.

Definition at line 355 of file critical_point.hh.

Referenced by operator=().

## operator=()

C3DCriticalPoint & C3DCriticalPoint::operator= | ( | const C3DCriticalPoint & | org | ) |

Assignment operator.

Parameters

  org | The critical point to be copied.

References C3DCriticalPoint(), get_a(), get_gamma(), get_point(), set_a(), set_gamma(), and set_point().

## operator==()

bool C3DCriticalPoint::operator== | ( | const C3DCriticalPoint & | cp | ) | const

inline

compare two critical points

- they are equal, if magnitude, phase portrait, and location are equal

Definition at line 388 of file critical_point.hh.

References C3DCriticalPoint().

## set_a()

void C3DCriticalPoint::set_a | ( | const C3DFMatrix & | a | ) |

inline

Return values

  the | phase portrait of the critical point

Definition at line 371 of file critical_point.hh.

Referenced by operator=().

## set_gamma()

void C3DCriticalPoint::set_gamma | ( | float | gamma_ | ) |

inline

set the magnitude if the critical point

Parameters

  gamma_ | the new magnitude of the critical point

Definition at line 382 of file critical_point.hh.

Referenced by operator=().

## set_point()

void C3DCriticalPoint::set_point | ( | const C3DFVector & | x | ) |

inline

Return values

  the | location of the critical point

Definition at line 366 of file critical_point.hh.

Referenced by operator=().

The documentation for this class was generated from the following file:

- critical_point.hh